# Stores current time of day as "timeOfDay" on the fake player "fp_HealthySleep".
execute store result score fp_HealthySleep timeOfDay run time query daytime

# Calculates the difference in time of day between this tick and the previous tick and stores the result as "timeDifference". Used for accomodating time acceleration from mods/plugins.
execute store result score fp_HealthySleep timeDifference run scoreboard players operation fp_HealthySleep timeOfDay -= fp_HealthySleep timePrevious

# Corrects timeDifference if its negative, which would happen if timeOfDay loops back from 23999 to 0 when timeDifference is calculated by adding 24000
# ex. timeOfDay - timePrevious = -22000   ->    -22000 + timeFix = timeDifference
# ex. 1000 - 23000 = -22000    ->    -22000 + 24000 = 2000 (actual time difference)
execute if score fp_HealthySleep timeDifference matches ..-1 run scoreboard players operation fp_HealthySleep timeDifference += fp_HealthySleep timeFix

# Sets timePrevious to current time to prepare for next time this function is run
execute store result score fp_HealthySleep timePrevious run time query daytime

# Loops function every 10 ticks
schedule function healthysleep:schedules/timedifference 10t
